From fa647ab1c8fb6580813973976a4fa646623b769d Mon Sep 17 00:00:00 2001
From: Markus Rathgeb <maggu2810@gmail.com>
Date: Thu, 5 Jun 2014 11:10:44 +0200
Subject: [PATCH] cgroup: add xattr support

Squashed commit of the following:

commit 83ba09a9229baee9af79724ab3ef0840c97b3b74
Author: Aristeu Rozanski <aris@redhat.com>
Date:   Thu Aug 23 16:53:30 2012 -0400

    cgroup: add xattr support

    This is one of the items in the plumber's wish list.

    For use cases:

    >> What would the use case be for this?
    >
    > Attaching meta information to services, in an easily discoverable
    > way. For example, in systemd we create one cgroup for each service, and
    > could then store data like the main pid of the specific service as an
    > xattr on the cgroup itself. That way we'd have almost all service state
    > in the cgroupfs, which would make it possible to terminate systemd and
    > later restart it without losing any state information. But there's more:
    > for example, some very peculiar services cannot be terminated on
    > shutdown (i.e. fakeraid DM stuff) and it would be really nice if the
    > services in question could just mark that on their cgroup, by setting an
    > xattr. On the more desktopy side of things there are other
    > possibilities: for example there are plans defining what an application
    > is along the lines of a cgroup (i.e. an app being a collection of
    > processes). With xattrs one could then attach an icon or human readable
    > program name on the cgroup.
    >
    > The key idea is that this would allow attaching runtime meta information
    > to cgroups and everything they model (services, apps, vms), that doesn't
    > need any complex userspace infrastructure, has good access control
    > (i.e. because the file system enforces that anyway, and there's the
    > "trusted." xattr namespace), notifications (inotify), and can easily be
    > shared among applications.
    >
    > Lennart

    v7:
    - no changes
    v6:
    - remove user xattr namespace, only allow trusted and security
    v5:
    - check for capabilities before setting/removing xattrs
    v4:
    - no changes
    v3:
    - instead of config option, use mount option to enable xattr support

    Original-patch-by: Li Zefan <lizefan@huawei.com>
    Cc: Li Zefan <lizefan@huawei.com>
    Cc: Tejun Heo <tj@kernel.org>
    Cc: Hugh Dickins <hughd@google.com>
    Cc: Hillf Danton <dhillf@gmail.com>
    Cc: Lennart Poettering <lpoetter@redhat.com>
    Signed-off-by: Li Zefan <lizefan@huawei.com>
    Signed-off-by: Aristeu Rozanski <aris@redhat.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>

commit cac4522c594319e40a39b5427623996761b24b81
Author: Aristeu Rozanski <aris@redhat.com>
Date:   Thu Aug 23 16:53:28 2012 -0400

    xattr: extract simple_xattr code from tmpfs

    Extract in-memory xattr APIs from tmpfs. Will be used by cgroup.

    $ size vmlinux.o
       text    data     bss     dec     hex filename
    4658782  880729 5195032 10734543         a3cbcf vmlinux.o
    $ size vmlinux.o
       text    data     bss     dec     hex filename
    4658957  880729 5195032 10734718         a3cc7e vmlinux.o

    v7:
    - checkpatch warnings fixed
    - Implement the changes requested by Hugh Dickins:
    	- make simple_xattrs_init and simple_xattrs_free inline
    	- get rid of locking and list reinitialization in simple_xattrs_free,
    	  they're not needed
    v6:
    - no changes
    v5:
    - no changes
    v4:
    - move simple_xattrs_free() to fs/xattr.c
    v3:
    - in kmem_xattrs_free(), reinitialize the list
    - use simple_xattr_* prefix
    - introduce simple_xattr_add() to prevent direct list usage

    Original-patch-by: Li Zefan <lizefan@huawei.com>
    Cc: Li Zefan <lizefan@huawei.com>
    Cc: Hillf Danton <dhillf@gmail.com>
    Cc: Lennart Poettering <lpoetter@redhat.com>
    Acked-by: Hugh Dickins <hughd@google.com>
    Signed-off-by: Li Zefan <lizefan@huawei.com>
    Signed-off-by: Aristeu Rozanski <aris@redhat.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>

    Conflicts:
    	mm/shmem.c

commit cd8f6a121c4e0e49e9c15f4f1ab1e2c534a65d3b
Author: Aristeu Rozanski <aris@redhat.com>
Date:   Thu Aug 23 16:53:29 2012 -0400

    cgroup: revise how we re-populate root directory

    When remounting cgroupfs with some subsystems added to it and some
    removed, cgroup will remove all the files in root directory and then
    re-popluate it.

    What I'm doing here is, only remove files which belong to subsystems that
    are to be unbinded, and only create files for newly-added subsystems.
    The purpose is to have all other files untouched.

    This is a preparation for cgroup xattr support.

    v7:
    - checkpatch warnings fixed
    v6:
    - no changes
    v5:
    - no changes
    v4:
    - refactored cgroup_clear_directory() to not use cgroup_rm_file()
    - instead of going thru the list of files, get the file list using the
      subsystems
    - use 'subsys_mask' instead of {added,removed}_bits and made
      cgroup_populate_dir() to match the parameters with cgroup_clear_directory()
    v3:
    - refresh patches after recent refactoring

    Original-patch-by: Li Zefan <lizefan@huawei.com>
    Cc: Li Zefan <lizefan@huawei.com>
    Cc: Hugh Dickins <hughd@google.com>
    Cc: Hillf Danton <dhillf@gmail.com>
    Cc: Lennart Poettering <lpoetter@redhat.com>
    Signed-off-by: Li Zefan <lizefan@huawei.com>
    Signed-off-by: Aristeu Rozanski <aris@redhat.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>

commit fa68f525a488e74d35f44e4cf5b1dbbc83ad8da9
Author: Tejun Heo <tj@kernel.org>
Date:   Tue Jul 3 10:38:06 2012 -0700

    cgroup: cgroup_rm_files() was calling simple_unlink() with the wrong inode

    While refactoring cgroup file removal path, 05ef1d7c4a "cgroup:
    introduce struct cfent" incorrectly changed the @dir argument of
    simple_unlink() to the inode of the file being deleted instead of that
    of the containing directory.

    The effect of this bug is minor - ctime and mtime of the parent
    weren't properly updated on file deletion.

    Fix it by using @cgrp->dentry->d_inode instead.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Reported-by: Al Viro <viro@ZenIV.linux.org.uk>
    Acked-by: Li Zefan <lizefan@huawei.com>
    Cc: stable@vger.kernel.org

commit 8ca67b989e17a377f6aee5e251b0fa1b10ccd70f
Author: Tejun Heo <tj@kernel.org>
Date:   Sat Jul 7 16:08:18 2012 -0700

    cgroup: fix cgroup hierarchy umount race

    48ddbe1946 "cgroup: make css->refcnt clearing on cgroup removal
    optional" allowed a css to linger after the associated cgroup is
    removed.  As a css holds a reference on the cgroup's dentry, it means
    that cgroup dentries may linger for a while.

    Destroying a superblock which has dentries with positive refcnts is a
    critical bug and triggers BUG() in vfs code.  As each cgroup dentry
    holds an s_active reference, any lingering cgroup has both its dentry
    and the superblock pinned and thus preventing premature release of
    superblock.

    Unfortunately, after 48ddbe1946, there's a small window while
    releasing a cgroup which is directly under the root of the hierarchy.
    When a cgroup directory is released, vfs layer first deletes the
    corresponding dentry and then invokes dput() on the parent, which may
    recurse further, so when a cgroup directly below root cgroup is
    released, the cgroup is first destroyed - which releases the s_active
    it was holding - and then the dentry for the root cgroup is dput().

    This creates a window where the root dentry's refcnt isn't zero but
    superblock's s_active is.  If umount happens before or during this
    window, vfs will see the root dentry with non-zero refcnt and trigger
    BUG().

    Before 48ddbe1946, this problem didn't exist because the last dentry
    reference was guaranteed to be put synchronously from rmdir(2)
    invocation which holds s_active around the whole process.

    Fix it by holding an extra superblock->s_active reference across
    dput() from css release, which is the dput() path added by 48ddbe1946
    and the only one which doesn't hold an extra s_active ref across the
    final cgroup dput().

    Signed-off-by: Tejun Heo <tj@kernel.org>
    LKML-Reference: <4FEEA5CB.8070809@huawei.com>
    Reported-by: shyju pv <shyju.pv@huawei.com>
    Tested-by: shyju pv <shyju.pv@huawei.com>
    Cc: Sasha Levin <levinsasha928@gmail.com>
    Acked-by: Li Zefan <lizefan@huawei.com>

commit 7db74fed5e5137076ce2e2ad8de8bcff08fbaca2
Author: Tejun Heo <tj@kernel.org>
Date:   Sat Jul 7 15:55:47 2012 -0700

    Revert "cgroup: superblock can't be released with active dentries"

    This reverts commit fa980ca87d15bb8a1317853f257a505990f3ffde.  The
    commit was an attempt to fix a race condition where a cgroup hierarchy
    may be unmounted with positive dentry reference on root cgroup.  While
    the commit made the race condition slightly more difficult to trigger,
    the race was still there and could be reliably triggered using a
    different test case.

    Revert the incorrect fix.  The next commit will describe the race and
    fix it correctly.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    LKML-Reference: <4FEEA5CB.8070809@huawei.com>
    Reported-by: shyju pv <shyju.pv@huawei.com>
    Cc: Sasha Levin <levinsasha928@gmail.com>
    Acked-by: Li Zefan <lizefan@huawei.com>

commit 8a817aa20830078f4027fe9c23ba30d79b1d9d06
Author: Salman Qazi <sqazi@google.com>
Date:   Thu Jun 14 14:55:30 2012 -0700

    cgroups: Account for CSS_DEACT_BIAS in __css_put

    When we fixed the race between atomic_dec and css_refcnt, we missed
    the fact that css_refcnt internally subtracts CSS_DEACT_BIAS to get
    the actual reference count.  This can potentially cause a refcount leak
    if __css_put races with cgroup_clear_css_refs.

    Signed-off-by: Salman Qazi <sqazi@google.com>
    Acked-by: Li Zefan <lizefan@huawei.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>

commit 8a0b43b1785f1eaf533693c65a5880a2951dbd1d
Author: Li Zefan <lizefan@huawei.com>
Date:   Wed Jun 6 19:12:30 2012 -0700

    cgroup: remove hierarchy_mutex

    It was introduced for memcg to iterate cgroup hierarchy without
    holding cgroup_mutex, but soon after that it was replaced with
    a lockless way in memcg.

    No one used hierarchy_mutex since that, so remove it.

    Signed-off-by: Li Zefan <lizefan@huawei.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>

commit 2d111e16082c524a12fcb86b7a7d09e46767d7e2
Author: Salman Qazi <sqazi@google.com>
Date:   Wed Jun 6 18:51:35 2012 -0700

    cgroup: make sure that decisions in __css_put are atomic

    __css_put is using atomic_dec on the ref count, and then
    looking at the ref count to make decisions.  This is prone
    to races, as someone else may decrement ref count between
    our decrement and our decision.  Instead, we should base our
    decisions on the value that we decremented the ref count to.

    (This results in an actual race on Google's kernel which I
    haven't been able to reproduce on the upstream kernel.  Having
    said that, it's still incorrect by inspection).

    Signed-off-by: Salman Qazi <sqazi@google.com>
    Acked-by: Li Zefan <lizefan@huawei.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>
    Cc: stable@vger.kernel.org

commit e742b3c8b306ebc06a1321b1437de20b935ac892
Author: Johannes Weiner <hannes@cmpxchg.org>
Date:   Tue May 29 15:06:24 2012 -0700

    kernel: cgroup: push rcu read locking from css_is_ancestor() to callsite

    Library functions should not grab locks when the callsites can do it,
    even if the lock nests like the rcu read-side lock does.

    Push the rcu_read_lock() from css_is_ancestor() to its single user,
    mem_cgroup_same_or_subtree() in preparation for another user that may
    already hold the rcu read-side lock.

    Signed-off-by: Johannes Weiner <hannes@cmpxchg.org>
    Cc: Konstantin Khlebnikov <khlebnikov@openvz.org>
    Acked-by: KAMEZAWA Hiroyuki <kamezawa.hiroyu@jp.fujitsu.com>
    Acked-by: Michal Hocko <mhocko@suse.cz>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Tejun Heo <tj@kernel.org>
    Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
    Signed-off-by: Linus Torvalds <torvalds@linux-foundation.org>

commit 4851db2641ccb6cdb2f32d9507505c52813562b3
Author: Tejun Heo <tj@kernel.org>
Date:   Thu May 24 08:24:39 2012 -0700

    cgroup: superblock can't be released with active dentries

    48ddbe1946 "cgroup: make css->refcnt clearing on cgroup removal
    optional" allowed a css to linger after the associated cgroup is
    removed.  As a css holds a reference on the cgroup's dentry, it means
    that cgroup dentries may linger for a while.

    cgroup_create() does grab an active reference on the superblock to
    prevent it from going away while there are !root cgroups; however, the
    reference is put from cgroup_diput() which is invoked on cgroup
    removal, so cgroup dentries which are removed but persisting due to
    lingering csses already have released their superblock active refs
    allowing superblock to be killed while those dentries are around.

    Given the right condition, this makes cgroup_kill_sb() call
    kill_litter_super() with dentries with non-zero d_count leading to
    BUG() in shrink_dcache_for_umount_subtree().

    Fix it by adding cgroup_dops->d_release() operation and moving
    deactivate_super() to it.  cgroup_diput() now marks dentry->d_fsdata
    with itself if superblock should be deactivated and cgroup_d_release()
    deactivates the superblock on dentry release.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Reported-by: Sasha Levin <levinsasha928@gmail.com>
    Tested-by: Sasha Levin <levinsasha928@gmail.com>
    LKML-Reference: <CA+1xoqe5hMuxzCRhMy7J0XchDk2ZnuxOHJKikROk1-ReAzcT6g@mail.gmail.com>
    Acked-by: Li Zefan <lizefan@huawei.com>

commit ee7067598065cd269825ac9812040c9e2760d4b4
Author: Eric W. Biederman <ebiederm@xmission.com>
Date:   Thu Nov 17 10:23:55 2011 -0800

    userns: Add a Kconfig option to enforce strict kuid and kgid type checks

    Make it possible to easily switch between strong mandatory
    type checks and relaxed type checks so that the code can
    easily be tested with the type checks and then built
    with the strong type checks disabled so the resulting
    code can be used.

    Require strong mandatory type checks when enabling the user namespace.
    It is very simple to make a typo and use the wrong type allowing
    conversions to/from userspace values to be bypassed by accident,
    the strong type checks prevent this.

    Acked-by: Serge Hallyn <serge.hallyn@canonical.com>
    Signed-off-by: Eric W. Biederman <ebiederm@xmission.com>

commit c5601b73aab8bac90be8b69968bd99e76c0e516d
Author: Eric W. Biederman <ebiederm@xmission.com>
Date:   Mon Nov 14 14:29:51 2011 -0800

    userns: Add kuid_t and kgid_t and associated infrastructure in uidgid.h

    Start distinguishing between internal kernel uids and gids and
    values that userspace can use.  This is done by introducing two
    new types: kuid_t and kgid_t.  These types and their associated
    functions are infrastructure are declared in the new header
    uidgid.h.

    Ultimately there will be a different implementation of the mapping
    functions for use with user namespaces.  But to keep it simple
    we introduce the mapping functions first to separate the meat
    from the mechanical code conversions.

    Export overflowuid and overflowgid so we can use from_kuid_munged
    and from_kgid_munged in modular code.

    Acked-by: Serge Hallyn <serge.hallyn@canonical.com>
    Signed-off-by: Eric W. Biederman <ebiederm@xmission.com>

commit 531ca1b1f0f5a873d89950d9683f44d9f7001cd3
Author: Mike Galbraith <mgalbraith@suse.de>
Date:   Sat Apr 21 09:13:46 2012 +0200

    cgroups: disallow attaching kthreadd or PF_THREAD_BOUND threads

    Allowing kthreadd to be moved to a non-root group makes no sense, it being
    a global resource, and needlessly leads unsuspecting users toward trouble.

    1. An RT workqueue worker thread spawned in a task group with no rt_runtime
    allocated is not schedulable.  Simple user error, but harmful to the box.

    2. A worker thread which acquires PF_THREAD_BOUND can never leave a cpuset,
    rendering the cpuset immortal.

    Save the user some unexpected trouble, just say no.

    Signed-off-by: Mike Galbraith <mgalbraith@suse.de>
    Acked-by: Peter Zijlstra <a.p.zijlstra@chello.nl>
    Acked-by: Thomas Gleixner <tglx@linutronix.de>
    Acked-by: Li Zefan <lizefan@huawei.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>

commit 5e4cba06cbe7fcd2b3ffee5c62f79acf4d126e92
Author: Tejun Heo <tj@kernel.org>
Date:   Tue Apr 10 10:16:36 2012 -0700

    cgroup: remove cgroup_subsys->populate()

    With memcg converted, cgroup_subsys->populate() doesn't have any user
    left.  Remove it.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizefan@huawei.com>

commit a7a79b552a3bf97788d8d22f2888a4f3310c128e
Author: Glauber Costa <glommer@parallels.com>
Date:   Mon Apr 9 19:36:34 2012 -0300

    cgroup: get rid of populate for memcg

    The last man standing justifying the need for populate() is the
    sock memcg initialization functions. Now that we are able to pass
    a struct mem_cgroup instead of a struct cgroup to the socket
    initialization, there is nothing that stops us from initializing
    everything in create().

    Signed-off-by: Glauber Costa <glommer@parallels.com>
    Acked-by: Kamezawa Hiroyuki <kamezawa.hiroyu@jp.fujitsu.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>
    CC: Li Zefan <lizefan@huawei.com>
    CC: Johannes Weiner <hannes@cmpxchg.org>
    CC: Michal Hocko <mhocko@suse.cz>

    Conflicts:
    	mm/memcontrol.c

commit bed6daf96599cbfdec259507eaccd1d1967f2a9a
Author: Glauber Costa <glommer@parallels.com>
Date:   Mon Apr 9 19:36:33 2012 -0300

    cgroup: pass struct mem_cgroup instead of struct cgroup to socket memcg

    The only reason cgroup was used, was to be consistent with the populate()
    interface. Now that we're getting rid of it, not only we no longer need
    it, but we also *can't* call it this way.

    Since we will no longer rely on populate(), this will be called from
    create(). During create, the association between struct mem_cgroup
    and struct cgroup does not yet exist, since cgroup internals hasn't
    yet initialized its bookkeeping. This means we would not be able
    to draw the memcg pointer from the cgroup pointer in these
    functions, which is highly undesirable.

    Signed-off-by: Glauber Costa <glommer@parallels.com>
    Acked-by: Kamezawa Hiroyuki <kamezawa.hiroyu@jp.fujitsu.com>
    Signed-off-by: Tejun Heo <tj@kernel.org>
    CC: Li Zefan <lizefan@huawei.com>
    CC: Johannes Weiner <hannes@cmpxchg.org>
    CC: Michal Hocko <mhocko@suse.cz>

commit 9a98fea2f9879cc84238cfb57fccf0956627cea1
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:56 2012 -0700

    cgroup: make css->refcnt clearing on cgroup removal optional

    Currently, cgroup removal tries to drain all css references.  If there
    are active css references, the removal logic waits and retries
    ->pre_detroy() until either all refs drop to zero or removal is
    cancelled.

    This semantics is unusual and adds non-trivial complexity to cgroup
    core and IMHO is fundamentally misguided in that it couples internal
    implementation details (references to internal data structure) with
    externally visible operation (rmdir).  To userland, this is a behavior
    peculiarity which is unnecessary and difficult to expect (css refs is
    otherwise invisible from userland), and, to policy implementations,
    this is an unnecessary restriction (e.g. blkcg wants to hold css refs
    for caching purposes but can't as that becomes visible as rmdir hang).

    Unfortunately, memcg currently depends on ->pre_destroy() retrials and
    cgroup removal vetoing and can't be immmediately switched to the new
    behavior.  This patch introduces the new behavior of not waiting for
    css refs to drain and maintains the old behavior for subsystems which
    have __DEPRECATED_clear_css_refs set.

    Once, memcg is updated, we can drop the code paths for the old
    behavior as proposed in the following patch.  Note that the following
    patch is incorrect in that dput work item is in cgroup and may lose
    some of dputs when multiples css's are released back-to-back, and
    __css_put() triggers check_for_release() when refcnt reaches 0 instead
    of 1; however, it shows what part can be removed.

      http://thread.gmane.org/gmane.linux.kernel.containers/22559/focus=75251

    Note that, in not-too-distant future, cgroup core will start emitting
    warning messages for subsys which require the old behavior, so please
    get moving.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Vivek Goyal <vgoyal@redhat.com>
    Cc: Johannes Weiner <hannes@cmpxchg.org>
    Cc: Michal Hocko <mhocko@suse.cz>
    Cc: Balbir Singh <bsingharora@gmail.com>
    Cc: KAMEZAWA Hiroyuki <kamezawa.hiroyu@jp.fujitsu.com>

    Conflicts:
    	kernel/cgroup.c

commit 37e6593be2a784f62e3b7c350a0b778dbc62f922
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:56 2012 -0700

    cgroup: use negative bias on css->refcnt to block css_tryget()

    When a cgroup is about to be removed, cgroup_clear_css_refs() is
    called to check and ensure that there are no active css references.

    This is currently achieved by dropping the refcnt to zero iff it has
    only the base ref.  If all css refs could be dropped to zero, ref
    clearing is successful and CSS_REMOVED is set on all css.  If not, the
    base ref is restored.  While css ref is zero w/o CSS_REMOVED set, any
    css_tryget() attempt on it busy loops so that they are atomic
    w.r.t. the whole css ref clearing.

    This does work but dropping and re-instating the base ref is somewhat
    hairy and makes it difficult to add more logic to the put path as
    there are two of them - the regular css_put() and the reversible base
    ref clearing.

    This patch updates css ref clearing such that blocking new
    css_tryget() and putting the base ref are separate operations.
    CSS_DEACT_BIAS, defined as INT_MIN, is added to css->refcnt and
    css_tryget() busy loops while refcnt is negative.  After all css refs
    are deactivated, if they were all one, ref clearing succeeded and
    CSS_REMOVED is set and the base ref is put using the regular
    css_put(); otherwise, CSS_DEACT_BIAS is subtracted from the refcnts
    and the original postive values are restored.

    css_refcnt() accessor which always returns the unbiased positive
    reference counts is added and used to simplify refcnt usages.  While
    at it, relocate and reformat comments in cgroup_has_css_refs().

    This separates css->refcnt deactivation and putting the base ref,
    which enables the next patch to make ref clearing optional.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

    Conflicts:
    	kernel/cgroup.c

commit 6ae80cc8464ab30d769e70241d61ddd45865f3bd
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:56 2012 -0700

    cgroup: implement cgroup_rm_cftypes()

    Implement cgroup_rm_cftypes() which removes an array of cftypes from a
    subsystem.  It can be called whether the target subsys is attached or
    not.  cgroup core will remove the specified file from all existing
    cgroups.

    This will be used to improve sub-subsys modularity and will be helpful
    for unified hierarchy.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit d73a46c95efe8514724ad48fcac7dfb29bcac923
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:56 2012 -0700

    cgroup: introduce struct cfent

    This patch adds cfent (cgroup file entry) which is the association
    between a cgroup and a file.  This is in-cgroup representation of
    files under a cgroup directory.  This simplifies walking walking
    cgroup files and thus cgroup_clear_directory(), which is now
    implemented in two parts - cgroup_rm_file() and a loop around it.

    cgroup_rm_file() will be used to implement cftype removal and cfent is
    scheduled to serve cgroup specific per-file data (e.g. for sysfs-like
    "sever" semantics).

    v2: - cfe was freed from cgroup_rm_file() which led to use-after-free
          if the file had openers at the time of removal.  Moved to
          cgroup_diput().

        - cgroup_clear_directory() triggered WARN_ON_ONCE() if d_subdirs
          wasn't empty after removing all files.  This triggered
          spuriously if some files were open during directory clearing.
          Removed.

    v3: - In cgroup_diput(), WARN_ONCE(!list_empty(&cfe->node)) could be
          spuriously triggered for root cgroups because they don't go
          through cgroup_clear_directory() on unmount.  Don't trigger WARN
          for root cgroups.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Glauber Costa <glommer@parallels.com>

commit 82408a55564678646baf265768ce3d33b064e25c
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    cgroup: relocate __d_cgrp() and __d_cft()

    Move the two macros upwards as they'll be used earlier in the file.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit 9fbb0bb71a3bbf8b30278100e7804a52e9b25e62
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    cgroup: remove cgroup_add_file[s]()

    No controller is using cgroup_add_files[s]().  Unexport them, and
    convert cgroup_add_files() to handle NULL entry terminated array
    instead of taking count explicitly and continue creation on failure
    for internal use.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit 9e8ad7804f72e8b6eff7d959390f0a2ce369fdd9
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    cgroup: convert memcg controller to the new cftype interface

    Convert memcg to use the new cftype based interface.  kmem support
    abuses ->populate() for mem_cgroup_sockets_init() so it can't be
    removed at the moment.

    tcp_memcontrol is updated so that tcp_files[] is registered via a
    __initcall.  This change also allows removing the forward declaration
    of tcp_files[].  Removed.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: KAMEZAWA Hiroyuki <kamezawa.hiroyu@jp.fujitsu.com>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Johannes Weiner <hannes@cmpxchg.org>
    Cc: Michal Hocko <mhocko@suse.cz>
    Cc: Balbir Singh <bsingharora@gmail.com>
    Cc: Glauber Costa <glommer@parallels.com>
    Cc: Hugh Dickins <hughd@google.com>
    Cc: Greg Thelen <gthelen@google.com>

commit b32023e8c10f97dbc094c7030f5b9d9f760e4935
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    memcg: always create memsw files if CONFIG_CGROUP_MEM_RES_CTLR_SWAP

    Instead of conditioning creation of memsw files on do_swap_account,
    always create the files if compiled-in and fail read/write attempts
    with -EOPNOTSUPP if !do_swap_account.

    This is suggested by KAMEZAWA to simplify memcg file creation so that
    it can use cgroup->subsys_cftypes.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: KAMEZAWA Hiroyuki <kamezawa.hiroyu@jp.fujitsu.com>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit 304613589145ed4689da8a882d9b6652b93f0b1e
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    cgroup: convert all non-memcg controllers to the new cftype interface

    Convert debug, freezer, cpuset, cpu_cgroup, cpuacct, net_prio, blkio,
    net_cls and device controllers to use the new cftype based interface.
    Termination entry is added to cftype arrays and populate callbacks are
    replaced with cgroup_subsys->base_cftypes initializations.

    This is functionally identical transformation.  There shouldn't be any
    visible behavior change.

    memcg is rather special and will be converted separately.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Paul Menage <paul@paulmenage.org>
    Cc: Ingo Molnar <mingo@elte.hu>
    Cc: Peter Zijlstra <peterz@infradead.org>
    Cc: "David S. Miller" <davem@davemloft.net>
    Cc: Vivek Goyal <vgoyal@redhat.com>

commit 45da257f6dcf9fdfab5a7594f271397cbc731f2b
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    cgroup: relocate cftype and cgroup_subsys definitions in controllers

    blk-cgroup, netprio_cgroup, cls_cgroup and tcp_memcontrol
    unnecessarily define cftype array and cgroup_subsys structures at the
    top of the file, which is unconventional and necessiates forward
    declaration of methods.

    This patch relocates those below the definitions of the methods and
    removes the forward declarations.  Note that forward declaration of
    tcp_files[] is added in tcp_memcontrol.c for tcp_init_cgroup().  This
    will be removed soon by another patch.

    This patch doesn't introduce any functional change.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit 9799ae980cdd1e311eba6b7e7f9f13aa3528a42d
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    cgroup: merge cft_release_agent cftype array into the base files array

    Now that cftype can express whether a file should only be on root,
    cft_release_agent can be merged into the base files cftypes array.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit bd6bb9b83926409b7ee13f03def2161266ca6d30
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:55 2012 -0700

    cgroup: implement cgroup_add_cftypes() and friends

    Currently, cgroup directories are populated by subsys->populate()
    callback explicitly creating files on each cgroup creation.  This
    level of flexibility isn't needed or desirable.  It provides largely
    unused flexibility which call for abuses while severely limiting what
    the core layer can do through the lack of structure and conventions.

    Per each cgroup file type, the only distinction that cgroup users is
    making is whether a cgroup is root or not, which can easily be
    expressed with flags.

    This patch introduces cgroup_add_cftypes().  These deal with cftypes
    instead of individual files - controllers indicate that certain types
    of files exist for certain subsystem.  Newly added CFTYPE_*_ON_ROOT
    flags indicate whether a cftype should be excluded or created only on
    the root cgroup.

    cgroup_add_cftypes() can be called any time whether the target
    subsystem is currently attached or not.  cgroup core will create files
    on the existing cgroups as necessary.

    Also, cgroup_subsys->base_cftypes is added to ease registration of the
    base files for the subsystem.  If non-NULL on subsys init, the cftypes
    pointed to by ->base_cftypes are automatically registered on subsys
    init / load.

    Further patches will convert the existing users and remove the file
    based interface.  Note that this interface allows dynamic addition of
    files to an active controller.  This will be used for sub-controller
    modularity and unified hierarchy in the longer term.

    This patch implements the new mechanism but doesn't apply it to any
    user.

    v2: replaced DECLARE_CGROUP_CFTYPES[_COND]() with
        cgroup_subsys->base_cftypes, which works better for cgroup_subsys
        which is loaded as module.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit f7c3e8e02ead0cffbbb1e80a20dab96317950429
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:54 2012 -0700

    cgroup: build list of all cgroups under a given cgroupfs_root

    Build a list of all cgroups anchored at cgroupfs_root->allcg_list and
    going through cgroup->allcg_node.  The list is protected by
    cgroup_mutex and will be used to improve cgroup file handling.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit 5b4f71cda30e97cdc874ca8a98992135de189d0b
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:54 2012 -0700

    cgroup: move cgroup_clear_directory() call out of cgroup_populate_dir()

    cgroup_populate_dir() currently clears all files and then repopulate
    the directory; however, the clearing part is only useful when it's
    called from cgroup_remount().  Relocate the invocation to
    cgroup_remount().

    This is to prepare for further cgroup file handling updates.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>

commit d8d6a3fa984898b1256b9c126c31acf85eb02d72
Author: Tejun Heo <tj@kernel.org>
Date:   Sun Apr 1 12:09:54 2012 -0700

    cgroup: deprecate remount option changes

    This patch marks the following features for deprecation.

    * Rebinding subsys by remount: Never reached useful state - only works
      on empty hierarchies.

    * release_agent update by remount: release_agent itself will be
      replaced with conventional fsnotify notification.

    v2: Lennart pointed out that "name=" is necessary for mounts w/o any
        controller attached.  Drop "name=" deprecation.

    Signed-off-by: Tejun Heo <tj@kernel.org>
    Acked-by: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Lennart Poettering <mzxreary@0pointer.de>

    Conflicts:
    	Documentation/feature-removal-schedule.txt

commit 4e5190f3c4ca056efdead0f98d081fc5f8c7aa11
Author: Daisuke Nishimura <nishimura@mxp.nes.nec.co.jp>
Date:   Wed Mar 10 15:22:05 2010 -0800

    cgroup: introduce coalesce css_get() and css_put()

    Current css_get() and css_put() increment/decrement css->refcnt one by
    one.

    This patch add a new function __css_get(), which takes "count" as a arg
    and increment the css->refcnt by "count".  And this patch also add a new
    arg("count") to __css_put() and change the function to decrement the
    css->refcnt by "count".

    These coalesce version of __css_get()/__css_put() will be used to improve
    performance of memcg's moving charge feature later, where instead of
    calling css_get()/css_put() repeatedly, these new functions will be used.

    No change is needed for current users of css_get()/css_put().

    Signed-off-by: Daisuke Nishimura <nishimura@mxp.nes.nec.co.jp>
    Acked-by: Paul Menage <menage@google.com>
    Cc: Balbir Singh <balbir@linux.vnet.ibm.com>
    Acked-by: KAMEZAWA Hiroyuki <kamezawa.hiroyu@jp.fujitsu.com>
    Cc: Li Zefan <lizf@cn.fujitsu.com>
    Cc: Daisuke Nishimura <nishimura@mxp.nes.nec.co.jp>
    Signed-off-by: Andrew Morton <akpm@linux-foundation.org>
    Signed-off-by: Linus Torvalds <torvalds@linux-foundation.org>

    Conflicts:
    	kernel/cgroup.c
---
 Documentation/cgroups/cgroups.txt          |   2 +-
 Documentation/feature-removal-schedule.txt |  21 +-
 block/blk-cgroup.c                         |  45 +-
 fs/xattr.c                                 | 166 +++++++
 include/linux/cgroup.h                     | 107 ++--
 include/linux/shmem_fs.h                   |   3 +-
 include/linux/uidgid.h                     | 176 +++++++
 include/linux/xattr.h                      |  48 ++
 include/net/sock.h                         |  12 +-
 include/net/tcp_memcontrol.h               |   4 +-
 init/Kconfig                               |  12 +-
 kernel/cgroup.c                            | 774 +++++++++++++++++++++--------
 kernel/cgroup_freezer.c                    |  11 +-
 kernel/cpuset.c                            |  31 +-
 kernel/sched/core.c                        |  16 +-
 kernel/sys.c                               |   2 -
 mm/memcontrol.c                            | 130 +++--
 mm/shmem.c                                 | 181 +------
 net/core/netprio_cgroup.c                  |  30 +-
 net/core/sock.c                            |  10 +-
 net/ipv4/tcp_memcontrol.c                  |  77 ++-
 net/sched/cls_cgroup.c                     |  31 +-
 security/device_cgroup.c                   |  10 +-
 23 files changed, 1241 insertions(+), 658 deletions(-)
 create mode 100644 include/linux/uidgid.h

diff --git a/block/blk-cgroup.c b/block/blk-cgroup.c
index ea84a23..126c341 100644
--- a/block/blk-cgroup.c
+++ b/block/blk-cgroup.c
@@ -28,34 +28,12 @@ static LIST_HEAD(blkio_list);
 struct blkio_cgroup blkio_root_cgroup = { .weight = 2*BLKIO_WEIGHT_DEFAULT };
 EXPORT_SYMBOL_GPL(blkio_root_cgroup);
 
-static struct cgroup_subsys_state *blkiocg_create(struct cgroup *);
-static int blkiocg_can_attach(struct cgroup *, struct cgroup_taskset *);
-static void blkiocg_attach(struct cgroup *, struct cgroup_taskset *);
-static void blkiocg_destroy(struct cgroup *);
-static int blkiocg_populate(struct cgroup_subsys *, struct cgroup *);
-
 /* for encoding cft->private value on file */
 #define BLKIOFILE_PRIVATE(x, val)	(((x) << 16) | (val))
 /* What policy owns the file, proportional or throttle */
 #define BLKIOFILE_POLICY(val)		(((val) >> 16) & 0xffff)
 #define BLKIOFILE_ATTR(val)		((val) & 0xffff)
 
-struct cgroup_subsys blkio_subsys = {
-	.name = "blkio",
-	.create = blkiocg_create,
-	.can_attach = blkiocg_can_attach,
-	.attach = blkiocg_attach,
-	.destroy = blkiocg_destroy,
-	.populate = blkiocg_populate,
-#ifdef CONFIG_BLK_CGROUP
-	/* note: blkio_subsys_id is otherwise defined in blk-cgroup.h */
-	.subsys_id = blkio_subsys_id,
-#endif
-	.use_id = 1,
-	.module = THIS_MODULE,
-};
-EXPORT_SYMBOL_GPL(blkio_subsys);
-
 static inline void blkio_policy_insert_node(struct blkio_cgroup *blkcg,
 					    struct blkio_policy_node *pn)
 {
@@ -1537,14 +1515,9 @@ struct cftype blkio_files[] = {
 		.read_map = blkiocg_file_read_map,
 	},
 #endif
+	{ }	/* terminate */
 };
 
-static int blkiocg_populate(struct cgroup_subsys *subsys, struct cgroup *cgroup)
-{
-	return cgroup_add_files(cgroup, subsys, blkio_files,
-				ARRAY_SIZE(blkio_files));
-}
-
 static void blkiocg_destroy(struct cgroup *cgroup)
 {
 	struct blkio_cgroup *blkcg = cgroup_to_blkio_cgroup(cgroup);
@@ -1658,6 +1631,22 @@ static void blkiocg_attach(struct cgroup *cgrp, struct cgroup_taskset *tset)
 	}
 }
 
+struct cgroup_subsys blkio_subsys = {
+	.name = "blkio",
+	.create = blkiocg_create,
+	.can_attach = blkiocg_can_attach,
+	.attach = blkiocg_attach,
+	.destroy = blkiocg_destroy,
+#ifdef CONFIG_BLK_CGROUP
+	/* note: blkio_subsys_id is otherwise defined in blk-cgroup.h */
+	.subsys_id = blkio_subsys_id,
+#endif
+	.base_cftypes = blkio_files,
+	.use_id = 1,
+	.module = THIS_MODULE,
+};
+EXPORT_SYMBOL_GPL(blkio_subsys);
+
 void blkio_policy_register(struct blkio_policy_type *blkiop)
 {
 	spin_lock(&blkio_list_lock);
